import type { Prop, SetupContext, VNodeChild } from 'vue';
/**
 * 装饰器处理
 */
export interface Hanlder {
    key: string;
    handler: (targetThis: any) => void;
}
declare type DefaultSlots = {
    default(): VNodeChild;
};
declare type MixDefaultSlots<T extends {}> = 'default' extends keyof T ? {} : DefaultSlots;
export declare type WithVSlots<T extends {}> = {
    'v-slots'?: 'slots' extends keyof T ? Partial<T['slots'] & {
        $stable: boolean;
    } & MixDefaultSlots<T['slots']>> : Partial<{
        $stable: boolean;
        default(): VNodeChild;
    }>;
};
export declare type WithSlotTypes<T extends {}> = Omit<SetupContext, 'slots'> & {
    slots: 'slots' extends keyof T ? Partial<T['slots'] & MixDefaultSlots<T['slots']>> : Partial<{
        default(): VNodeChild;
    }>;
};
declare type ModelProps<T extends {}> = Exclude<{
    [Prop in keyof T]: T extends {
        [k in Prop as `onUpdate:${k & string}`]?: any;
    } ? Prop : never;
}[keyof T], undefined>;
export declare type WithVModel<T extends {}, U extends keyof T = ModelProps<T>> = TransformModelValue<{
    [k in U as `v-model:${k & string}`]?: T[k] | [T[k], string[]];
}>;
export declare type TransformModelValue<T extends {}> = 'v-model:modelValue' extends keyof T ? Omit<T, 'v-model:modelValue'> & {
    ['v-model']?: T['v-model:modelValue'];
} : T;
export declare type ComponentProps<T extends {}> = ComponentPropsObject<T> | Array<keyof Omit<T, 'slots'>>;
export declare type ComponentPropsObject<T extends {}> = {
    [U in keyof Omit<T, 'slots'>]-?: Prop<any>;
};
export declare type ComponentSlots<T extends {
    props: any;
}> = T['props']['v-slots'];
/** 为了阻止ts把不相关的类也解析到metadata数据中，用这个工具类型包装一下类 */
export declare type ClassType<T> = T;
export {};
